<template lang="pug">
  .all.pa4.mw9.center.vh-100.flex.flex-column(v-if="activeBuilding")
    .br3.ph3.pv2.bg-moon-gray
      building-button(
        v-for="building in buildingList"
        :key="building.name"
        :name="building.name"
        :count="building.count"
        :active="activeBuilding.name === building.name"
      )
    .mt3.br3.ba.b--light-silver.bg-white.flex.flex-auto.items-stretch
      .all__sidebar.pa3
        b-input.mb3(
          v-model.trim="memberQuery"
          placeholder="尋找室友或房號"
          icon="search"
        )
        member-chat-state(
          v-for="member in visibleMember"
          :key="member.id"
          :member="member"
          :active="member.id === activeMember.id"
          @click="chooseMember"
        )
      .all__main.bl.br.b--light-silver
        chat-room(
          :channel-id="activeMember.channelId"
          :channel-type="activeMember.channelType"
          :ticketId="lastTicketId"
        )
          .flex-auto.tr.pr2(slot="bottom-tooltip")
            b-button(
              v-show="!activeMember.isRead"
              type="is-light"
              @click="markAsRead"
            ) 標為已讀
      .all__sidebar
        .pa3(v-if="activeMember.booking")
          h2.b.f5.mb2 相關通報
          related-issues(:booking="activeMember.booking")
</template>
<script>
import api from '~/utils/api'
import { issueMixin } from '~/utils/mixins'
import BuildingButton from '~/components/BuildingButton'
import MemberChatState from '~/components/MemberChatState'
import ChatRoom from '~/components/ChatRoom'
import RelatedIssues from '~/components/RelatedIssues'

export default {
  components: {
    BuildingButton,
    MemberChatState,
    ChatRoom,
    RelatedIssues
  },
  mixins: [issueMixin],
  layout: 'private',
  data () {
    return {
      chats: [],
      memberQuery: ''
    }
  },
  computed: {
    targetRoom () {
      return this.$route.params.room || ''
    },
    targetBuilding () {
      return this.$route.params.building || ''
    },
    lastTicketId () {
      if (!this.activeMember) {
        return ''
      }
      const tickets = this.activeMember.tickets
      if (tickets.length) {
        return tickets[tickets.length - 1].id
      }
      return ''
    },
    memberList () {
      const memberMap = {}
      this.chats.forEach((chat) => {
        if (!chat.booking) {
          return
        }
        memberMap[chat.booking.email] = chat
      })

      return Object.values(memberMap)
    },
    visibleMember () {
      if (!this.memberQuery) {
        return this.memberList
      }
      return this.memberList.filter((member) => {
        const haystack = [
          member.booking.username,
          member.booking.roomId
        ]
        return haystack.some(hay => hay.includes(this.memberQuery))
      })
    },
    activeMember () {
      const ret = this.visibleMember.find((member) => {
        return member.booking.roomId === this.targetRoom &&
          member.booking.buildingId === this.targetBuilding
      })

      if (ret || this.visibleMember.length === 0) {
        return ret
      }
      if (!ret && this.targetRoom) {
        this.$buefy.snackbar.open(`找不到住在 ${this.targetBuilding} ${this.targetRoom} 的室友呦`)
      }
      return this.visibleMember[0]
    },
    buildingList () {
      const buildingMap = {}
      this.chats.forEach((chat) => {
        if (chat.booking) {
          const name = chat.booking.buildingId
          if (!buildingMap[name]) {
            buildingMap[name] = 0
          }
          if (!chat.isRead) {
            buildingMap[name] += 1
          }
        }
      })
      return Object.keys(buildingMap).map((name) => {
        return {
          name,
          count: buildingMap[name]
        }
      })
    },
    activeBuilding () {
      const ret = this.buildingList.find(building => building.name === this.targetBuilding)
      if (ret || this.buildingList.length === 0) {
        return ret
      }
      if (!ret && this.targetBuilding) {
        this.$buefy.snackbar.open(`找不到 ${this.targetBuilding} 呦`)
      }
      return this.buildingList[0]
    }
  },
  created () {
    this.loadChat()
  },
  methods: {
    async loadChat () {
      this.chats = await api.chat.find()
    },
    chooseMember (member) {
      this.$router.push({
        name: 'chat-all-building-room',
        params: {
          building: member.booking.buildingId,
          room: member.booking.roomId
        }
      })
    },
    async markAsRead () {
      await api.chat.markAsRead(this.activeMember.id)
      this.loadChat()
    }
  }
}
</script>
<style lang="scss" scoped>
$sidebarWidth: 18rem;
.all {
  &__sidebar {
    width: $sidebarWidth;
    max-height: 100%;
    overflow-x: auto;
  }
  &__main {
    width: calc( 100% - #{$sidebarWidth} * 2 );
  }
  /deep/ {
    .related a {
      border: #aaa 1px solid;
    }
  }
}
</style>
